package gui;

import java.awt.GridLayout;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;

import javax.swing.Box;
import javax.swing.JPanel;
import javax.swing.JTextField;

import logic.Translator;

public class CodonSelector extends JPanel {
	private static final long serialVersionUID = 1L;
	private JTextField alternatives[] = new JTextField[6];
	private SequenceDrawing linkedSequenceArea;

	public CodonSelector(SequenceDrawing SequenceArea) {
		linkedSequenceArea = SequenceArea;
		setLayout(new GridLayout(1, 0, 0, 0));
		for (int i = 0; i < 6; i++) {
			alternatives[i] = new JTextField();
			alternatives[i].setColumns(5);
			alternatives[i].setEditable(false);
			alternatives[i].addMouseListener(new MouseAdapter() {
				@Override
				public void mouseClicked(MouseEvent e) {
					JTextField clickSource = (JTextField) e.getSource();
					String newCodon = clickSource.getText().split(" ")[0];
					if (!newCodon.isEmpty()) {
						linkedSequenceArea.mutate(newCodon.replace("T", "U"));
						showAlternatives(Translator.getInstance().sameSense(newCodon));
					}
				}
			});
		}

		Box Box1 = Box.createVerticalBox();
		for (int i = 0; i < 3; i++)
			Box1.add(alternatives[i]);
		add(Box1);

		Box Box2 = Box.createVerticalBox();
		for (int i = 3; i < 6; i++)
			Box2.add(alternatives[i]);
		add(Box2);
	}

	void showAlternatives(ArrayList<String> alt) {
		for (int i = 0; i < 6; i++)
			alternatives[i].setText("");
		for (int i = 0; i < alt.size(); i++) {
			alternatives[i].setText(alt.get(i) + " \t " + linkedSequenceArea.getSeqWithRibo().getDelay(alt.get(i)));
		}
	}
}
